# w.c.s. - web application for online forms
# Copyright (C) 2005-2017  Entr'ouvert
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.

import quixote
from django.core.management.base import BaseCommand

from wcs.qommon.publisher import get_publisher_class


class Command(BaseCommand):
    help = 'Migrate databases'

    def handle(self, verbosity=1, **options):
        Publisher = get_publisher_class()
        quixote.cleanup()
        pub = Publisher.create_publisher()
        for tenant in Publisher.get_tenants():
            pub = Publisher.create_publisher()
            pub.set_tenant(tenant)
            if pub.is_using_postgresql():
                if verbosity:
                    print('Running migrations for', tenant.hostname)
                pub.migrate_sql()
                pub.cleanup()
            quixote.cleanup()
